#!/bin/bash
#
# Shell script to prepare the Makefile
#
# Copyright 2014 by guy maurel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# 12 january 2014
#
# where you have store the script and the awk-program
DIR=./
# YOU might need to change the name of YOUR compiler in the awk-file below
#
#set -x
#
numberOfParameter=$#
if [ $numberOfParameter -eq 0 ] ;
then
  # Parameter is missing, use the actual directory
  WHERE="./"
else
  WHERE=${1}
fi
#
LIST_OF_MAKE=`find ${WHERE} -name build.make`
for make_file in ${LIST_OF_MAKE}
do
  echo "The Makefile is "${make_file}
  grep -n "Prepare-build_make_files.sh" ${make_file} > /dev/null 2>&1
  howStatus=$?
  if [ $howStatus == "0" ] ;
  then
    echo "The file already prepared"
  else
    echo "# Prepare-build_make_files.sh" >                        ${make_file}.new
    echo "# prepared the file to generate assembler code file" >> ${make_file}.new
    # YOU might need to change the name of YOUR compiler in the awk-file below
    gawk -f ${DIR}/prepare.awk ${make_file} >>                    ${make_file}.new
    mv ${make_file}  ${make_file}.orig
    mv ${make_file}.new  ${make_file}
    echo "The file is now prepared"
  fi
done
